
package xelfi.awt;

import xelfi.util.Debug;

/**
 * Gives an information about drag-drop operation.
 * It is used when tree view objects notify their parents
 * about succesfull drag-drop operation.
	Last change:  DF   16 Mar 97    4:24 pm
*/
public class XFDragDropInfo implements XelfiDragDropInfo {

  private Object source, destination, previousItem;
  
  /**
	 * Constructs XFDragDropInfo object with specified 
	 * source and destination
	*/
  public XFDragDropInfo (Object source, Object destination,
                         Object previousItem) {
		this.source = source;
    this.destination = destination;
    this.previousItem = previousItem;
	}

	/**
	 * Returns the source of the drag-drop operation
	*/
	public Object getSource () {
		return source;
	}

	/**
	 * Returns the destination of the drag-drop operation
	*/
	public Object getDestination () {
		return destination;
  }

  /**
   * Returns the item after which is source placed
   * in destination container
  */
  public Object getPreviousItem () {
    return previousItem;
  }

}
