package xelfi.awt;

import java.awt.*;

/**
 * Any object which wants to be showable as element of tree 
 * structure on the screen has to implement this interface.<br>
 * So if tou want your graphics element to be viewable in tree,
 * implement this interface and use XFTreeView, XFTreeViewCanvas,
 * XFTreeViewPanel classes.
 * 
 * @version 1.02, 5 Feb 1997
 * @author Dafe
*/
public interface XelfiTreeViewElement extends XelfiListViewElement {
	/**
	 * Returns true if element can have children, false otherwise
	*/
	public boolean canHaveChildren ();
	/**
	 * Returns true if element is pulled down, false otherwise
	*/
	public boolean isPulled ();
	/**
	 * Sets element to specified state, true = pulled down
	*/
	public void pull (boolean state);
}


