

package xelfi.browser.util;
import xelfi.browser.util.Member;
import xelfi.browser.util.HMember;

/**
 * There are some sort methods implemented in this class
 */
public class Sort
{
    /**
     * This method creates depth array for array of Members.
     * @param v array of members
     * @see BTree
     */
    public static int[] hierarchy(Member[] v)
    {
        //System.out.println("hierarchy");
        int i,k = v.length;
        int[] depth = new int[k];

        if( k < 2 ) return depth;

        BTree tree = BTree.toTree(v);

        //System.out.println("hierarchy middle");

        for(i=0;i<k;i++)
            depth[i] = 1;

        depth = BTree.toDepthMap(tree,v,depth);

        //System.out.println("hierarchy end");
        return depth;


/*        for(i=k-1;i>=0;i--)
        {
            if( depth[i] != 1 ) continue;

            String name = ((HMember)v[i]).getParent();
            for(j=0;j<k;j++)
            {
                if( v[j].getKey().equals(name) )
                {// move
                    for(l=i+1;i<k;l++)
                        if( depth[l] == 1 ) break;

                }
            }
        }*/

    }
    /**
     * This method usses default method of sorting to sort
     * array of Members
     * @param v array of Members
     * @return sorted array
     */
    public static Member[] sort(Member[] v)
    {
        return bubleSort(v,0,v.length);
    }
    /**
     * This method usses default method of sorting to sort
     * part of array of Members
     * @param Member[] v array of Members
     * @param int from
     * @param int to
     * @return Member[] sorted array.
     */
    public static Member[] sort(Member[] v,
        int from,int to)
    {
        return bubleSort(v,from,to);
    }
    /**
     * This method usses Buble-sort method to sort
     * part of array of Members
     * @param Member[] v array of Members
     * @param int from
     * @param int to
     * @return Member[] sorted array.
     */
    public static Member[] bubleSort(Member[] v,
        int from,int to)
    {
        //System.out.println("Sort");
        boolean end;
        Member pom1,pom2;
        int l = to - 1;
        do
        {
            end = true;
            for(int i = from;i<l;i++)
            {
                if( (pom1 = v[i]).getKey().
                    toLowerCase().compareTo(
                    (pom2 = v[i+1]).getKey().
                    toLowerCase()) > 0 )
                {
                    v[i] = pom2;
                    v[i+1] = pom1;
                    end = false;
                }
            }
            l--;
        }while( !end );
        //System.out.println("Sort end");
        return v;
    }
    /**
     * This method usses Buble-sort method to sort
     * array of Members
     * @param v array of Members
     * @return sorted array
     */
    public static Member[] bubleSort(Member[] v)
    {
        return bubleSort(v,0,v.length);
    }
}

