
package xelfi.browser.view;

import xelfi.util.EnhProperties;
import xelfi.browser.document.BrSettings;

import java.awt.Panel;
import java.awt.Window;

public class BrowserOptions implements xelfi.top.XelfiOptions
{

    /** This is called on xelfi start, if config file is found. Load your own values from src. Note that this
     call need not be done (if there's no config file).
     */
    public void loadProperties(EnhProperties src)
    {
        //System.out.println("BrowserOptions loadP.");
        BrowserSettings.settings = new BrSettings(src,-1);
        BrowserSettings.properties = src;
        //System.out.println("BrowserOptions loadP. end");
    }

    /** Save your values into dest */
    public void storeProperties(EnhProperties dest)
    {
        BrowserSettings.Destroy();
        BrowserSettings.settings.storeProperty(dest,-1);
        int i,k = BrowserSettings.getBWNumber();
        for(i=0;i<k;i++)
        {
            BrowserSettings.getBPanel(i).settings.
                storeProperty(dest,i);
        }
    }

    /** Return a panel where an user can edit your options or null if you don't want your
     options to be user editable.
     */
    public Panel getPanel()
    {
        return new BrowserSettingsPanel(null);
    }

    /** Return name of a tab with your panel or null if your getPanel() returns null. */
    public String getTabName()
    {
        return "Browser";
    }

    /** This is called when values from the Panel p are becomming valid (use pressed OK button). Parameter
    p is a Panel returned by getPanel().
    */
    public void onOK(Panel p)
    {
        ((BrowserSettingsPanel)p).onOk();
       return;
    }


}




