
package xelfi.browser.view;

import java.awt.*;
import java.io.IOException;

import xelfi.browser.document.*;
import xelfi.browser.util.modalDialog;



public class HintWindow extends xelfi.top.TopDialog
{
    BrComponent component;

    public HintWindow(Frame parent,BrComponent c) {

       super(parent,"Hint window", false);

        component = c;

        addNotify();
        resize(insets().left + insets().right + 2, insets().top + insets().bottom + 8);

        setLayout(new BorderLayout());


        Panel panel = new Panel();
        panel.setLayout(new FlowLayout());
        buttonOK=new Button("OK");
        panel.add(buttonOK);
        buttonCancel=new Button("Cancel");
        panel.add(buttonCancel);
        add("South",panel);

        edit = new TextArea();
        add("Center",edit);


        try
        {
            if( c instanceof BrMember )
            {
                String s = ((BrMember)c).getHint();
                edit.setText(s);
            }else
            if( c instanceof BrObject )
            {
                String s = ((BrObject)c).getHint();
                edit.setText(s);
            }
        }catch( IOException e)
        {
            dispose();
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"IO Exception ",
                null,null,
                modalDialog.OK);
        }
        resize(insets().left + insets().right + preferredSize().width, insets().top + insets().bottom + preferredSize().height);

       setResizable(true);
        Dimension d = getToolkit().getScreenSize();
        move( (d.width - size().width) / 2 , (d.height - size().height) / 2 );
        show();
        resize(preferredSize());

    }

    /*public synchronized void show() {
       Rectangle bounds = getParent().bounds();
       Rectangle abounds = bounds();

       move(bounds.x + (bounds.width - abounds.width)/ 2,
            bounds.y + (bounds.height - abounds.height)/2);

       super.show();
    }*/

    public synchronized void wakeUp() {
       notify();
    }

    public boolean handleEvent(Event event) {

       if (event.id == Event.WINDOW_DESTROY) {
           dispose();
           return true;
       }else
        if( event.id == Event.ACTION_EVENT )
        {
            if( event.target == buttonOK )
            {
                dispose();
                try
                {
                    if( component instanceof BrMember )
                    {
                        ((BrMember)component).setHint(edit.getText());
                    }else
                    if( component instanceof BrObject )
                    {
                        ((BrObject)component).setHint(edit.getText());
                    }
                }catch(IOException e)
                {
                    new modalDialog(BrowserSettings.mainWindow,
                        null,0,"IO Exception ",
                        null,null,
                        modalDialog.OK);
                }catch(xelfi.editor.NotAllowedException e)
                {
                    new modalDialog(BrowserSettings.mainWindow,
                        null,0,"It's impossible to delete text here !!! ",
                        null,null,
                        modalDialog.OK);
                }
                return true;
            }else
            if( event.target == buttonCancel )
            {
                dispose();
                return true;
            }
        }
       return super.handleEvent(event);
    }

    Button buttonOK;
    Button buttonCancel;
    TextArea edit;

}



