/** AddListItem dialog
* @author: Filip Dvorak
* @version: 1.3
*/

package xelfi.compiler;

import java.awt.*;
import java.util.*;

import xelfi.top.*;
import xelfi.top.visual.*;

class AddListItemDialog extends Dialog
{

  protected PackageListDialog parentDialog;
  protected Vector toAdd;
  protected TextField tx;
  protected Button butOK, butCancel;

  AddListItemDialog(PackageListDialog par)
  {
    super(TopLevel.getMenu(), "Inset package", true);

    toAdd = par.plist;
    parentDialog = par;

    RowLayout dl = new RowLayout();
    setLayout(dl);
    RowLayoutProperties dp = new RowLayoutProperties(new Insets(2, 2, 2, 4));
    dp.topSpaceGrowth = 0.1f;
    dp.leftSpaceGrowth = 0.1f;
    dp.leftSpaceGrowth = 0.15f;

    Label l = new Label("Enter new pacakge");
    add(l);
    dl.add(l, dp);
      // text field
    tx = new TextField(36);
    dp.topSpaceGrowth = 0.04f;
    add(tx);
    dl.add(tx, dp);
      // button panel
    Panel bp = new Panel();
    dp.compGrowth = 0.02f;
    dp.topSpaceGrowth = 0.74f;
    dp.bottomSpaceGrowth = 0.1f;
    add(bp);
    dl.add(bp, dp);

      // button panel setup
    ColLayout bpl = new ColLayout();
    ColLayoutProperties bpp = new ColLayoutProperties(new Insets(2, 2, 2, 2), 0.03f, 0.46f, 0.02f);
    bp.setLayout(bpl);
      // ok
    butOK = new Button(" OK ");
    bp.add(butOK);
    bpl.add(butOK, bpp);
      // Cancel
    bpp.leftSpaceGrowth = 0;
    bpp.rightSpaceGrowth = 0.46f;
    butCancel = new Button("Cancel");
    bp.add(butCancel);
    bpl.add(butCancel, bpp);

    pack();
    pack();
  }

  public boolean action(Event e, Object arg)
  {
    if(e.target == butCancel)
    {
      hide();
      dispose();
      return true;
    }
    else if(e.target == butOK)
    {
      onOK();
      return true;
    }
    return super.action(e, arg);
  }

  public boolean handleEvent(Event evt)
  {
    switch(evt.id)
    {
      case Event.WINDOW_DESTROY:
        if(evt.target == this)
        {
          hide();
          dispose();
          return true;
        }
    }
    return super.handleEvent(evt);
  }

  protected void onOK()
  {
    String newPack = tx.getText();
    if(newPack.length() == 0) return;

    toAdd.addElement(newPack);
    hide();
    dispose();
    parentDialog.list.addItem(tx.getText());
    parentDialog.requestFocus();
  }

  public boolean keyDown(Event  e, int  key)
  {
    if(key == '\n')
    {
      onOK();
      return true;
    }
    else return false;
  }

  public void show()
  {
    if(getPeer() == null) addNotify();
    Dimension scr = Toolkit.getDefaultToolkit().getScreenSize(), me = size();

    move((scr.width - me.width) / 2, (int)((scr.height - me.height) / 2.4));
    super.show();
    tx.requestFocus();
  }

  public Insets insets()   // Under JDK 1.0.2 for win95 insets doesnt work. This patch should help.
  {
    Insets i = super.insets();
    if(getPeer() != null && (i.top < 0 || i.bottom < 0 || i.left < 0 || i.right < 0))
      return new Insets(28, 4, 4, 4);
    else return i;
  }
}







