/** ErrorDatabase class
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi.compiler;

import java.util.*;

  /** Class keepeng all arrorr from compilation. Error lists can be retrieved. But adding
    new error (and error lists) can be done only inside the package. */
public class ErrorDatabase
{
    /** Table of error lists. */
  protected static Hashtable table = new Hashtable(20, 0.8f);

    /** When calling be sure that ErrorList for that class doesn't exist. */
  private static ErrorList installErrorList(String className)
  {
    ErrorList l = new ErrorList(className);
    table.put(className, l);
    return l;
  }

    /** Get a list of errors. 
      @param className name of the class for which an error list is required.
      @return the error list or null if no error list is installed.*/
  public static synchronized ErrorList getErrorList(String className)
  {
    return (ErrorList)table.get(className);
  }

  static synchronized void removeErrors(String className)
  {
    ErrorList l = (ErrorList)table.remove(className);
    if(l != null) l.removed();
  }

    /** Installs new ErrorList if it doesn't exist. */
  static synchronized void addError(ErrorDescription desc, String className)
  {
    ErrorList l = (ErrorList)table.get(className);
    if(l == null) l = installErrorList(className);
    l.addError(desc);
  }
}




