/**
* Xelfi
*/

package xelfi.design.components.dialogs;

import java.awt.*;
import xelfi.awt.Panel3D;
import xelfi.awt.SpinEdit;
import xelfi.design.util.GridInfo;
import xelfi.design.util.XFDesignOptions;

public class XFGridSetDialog extends Dialog {
  public static final int RES_OK = 1;
  public static final int RES_CANCEL = 2;

  public boolean finished = false;
  public int result = 0;
  public GridInfo gi;
	
  public XFGridSetDialog(Frame parent, GridInfo aGi) {
    super(parent, true);
    setResizable(false);
    gi = aGi;

    setLayout(new BorderLayout());
    panel1 = new Panel();
    panel1.setLayout(new GridLayout(1, 2));
    add("Center", panel1);
    panelX = new Panel3D();
    panelX.setLayout(new FlowLayout());
    panelX.setCaption("Grid X");
    panel1.add(panelX);
    spinX = new SpinEdit();
    spinX.setValue(gi.gridX());
    spinX.setMinimum(1);
    spinX.setMaximum(1000);
    panelX.add(spinX);
    panelY = new Panel3D();
    panelY.setLayout(new FlowLayout());
    panelY.setCaption("Grid Y");
    panel1.add(panelY);
    spinY = new SpinEdit();
    spinY.setValue(gi.gridY());
    spinY.setMinimum(1);
    spinY.setMaximum(1000);
    panelY.add(spinY);
    panel2 = new Panel();
    panel2.setLayout(new FlowLayout());
    add("South", panel2);
    buttonOK = new Button("OK");
    panel2.add(buttonOK);
    buttonCancel = new Button("Cancel");
    panel2.add(buttonCancel);
    buttonNoGrid = new Button("NoGrid");
    panel2.add(buttonNoGrid);
    buttonDefault = new Button("Default");
    panel2.add(buttonDefault);
    addNotify();
    reshape(0, 0, 300, 120);
  }

  public boolean handleEvent(Event evt) {
    if ((evt.target == this) && (evt.id == Event.WINDOW_DESTROY)) {
      hide();
      dispose();
    }
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonDefault)
      return onDefault(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonNoGrid)
      return onNoGrid(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonCancel)
      return onCancel(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonOK)
      return onOK(evt);
    return super.handleEvent(evt);
  }

// Event handlers

  public boolean onDefault(Event evt) {
    gi.setGrid(XFDesignOptions.gridX, XFDesignOptions.gridY);
    result = RES_OK; finished = true;
    hide(); dispose();
    return true;
  }

  public boolean onNoGrid(Event evt) {
    gi.setGrid(1, 1);
    result = RES_OK; finished = true;
    hide(); dispose();
    return true;
  }

  public boolean onCancel(Event evt) {
    result = RES_CANCEL; finished = true;
    hide(); dispose();
    return true;
  }

  public boolean onOK(Event evt) {
    gi.setGrid(spinX.getValue(), spinY.getValue());
    result = RES_OK; finished = true;
    hide(); dispose();
    return true;
  }

// End of event handlers

  Panel panel1;
  Panel3D panelX;
  SpinEdit spinX;
  Panel3D panelY;
  SpinEdit spinY;
  Panel panel2;
  Button buttonOK;
  Button buttonCancel;
  Button buttonNoGrid;
  Button buttonDefault;
}