/**
* Xelfi
*/

package xelfi.design.components.dialogs;

/**
 * This is the first dialog generated by Xelfi IDE.
 * @version 	1.0, 27 Jan 1997
 * @author 	Petr Hamernik, Xelfi IDE
 */

import java.io.*;
import java.awt.Color;
import java.awt.Frame;
import xelfi.design.components.XelfiDesignComponent;
import xelfi.design.components.dialogs.ImageNameSelectThread;
import xelfi.design.components.property.XFImageName;
import java.awt.*;
import xelfi.awt.Panel3D;

// Here go your own imports:

public class XFImageNameDialog extends Dialog {
	public static final int RES_OK = 1;
	public static final int RES_CANCEL = 2;

	public boolean finished = false;
	public int result = 0;
	public XFImageName iname = null;
	
	Panel3D panel3D1;
	Checkbox checkURL;
	Checkbox checkPath;
	Checkbox checkPackage;
	TextField textField1;
	TextField textField2;
	Label label1;
	Label label2;
	Button browseButton;
	Button OKBut;
	Button cancelBut;

	public XFImageNameDialog(Frame parent) {
		super(parent, "Image File Selection", true);
		setResizable(false);

		setLayout(null);
		addNotify();

		int x = insets().left;
		int y = insets().top + 20;

		panel3D1 = new Panel3D();
		panel3D1.setLayout(null);
		add(panel3D1);
		panel3D1.reshape(x+10,y+10,120,92);
		checkURL = new Checkbox("URL");
		panel3D1.add(checkURL);
		checkURL.reshape(10,5,100,18);
		checkPath = new Checkbox("Path");
		panel3D1.add(checkPath);
		checkPath.reshape(10,35,100,18);
		checkPackage = new Checkbox("Package");
		panel3D1.add(checkPackage);
		checkPackage.reshape(10,65,100,18);
		checkPackage.disable();

		CheckboxGroup grp = new CheckboxGroup();
		checkURL.setCheckboxGroup(grp);
		checkPath.setCheckboxGroup(grp);
		checkPackage.setCheckboxGroup(grp);

		textField1 = new TextField();
		add(textField1);
		textField1.reshape(x+220,y+15,250,25);
		textField2 = new TextField();
		add(textField2);
		textField2.reshape(x+220,y+45,250,25);
		label1 = new Label("");
		add(label1);
		label1.reshape(x+130,y+20,80,18);
		label1.setAlignment(Label.RIGHT);
		label2 = new Label("File name");
		add(label2);
		label2.reshape(x+130,y+50,80,18);
		label2.setAlignment(Label.RIGHT);
		browseButton = new Button("Browse");
		add(browseButton);
		browseButton.reshape(x+483,y+18,59,24);
		browseButton.disable();
		OKBut = new Button("OK");
		add(OKBut);
		OKBut.reshape(x+364,y+100,70,20);
		cancelBut = new Button("Cancel");
		add(cancelBut);
		cancelBut.reshape(x+445,y+100,70,20);
	    resize(563, 175);
		iname = new XFImageName(XFImageName.IN_PATH);
	}

	public synchronized void show() {
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension screenSize = toolkit.getScreenSize();
		Dimension dialogSize = size();
		move((screenSize.width-dialogSize.width)/2,(screenSize.height-dialogSize.height)/2);
		super.show();
	}

	public boolean handleEvent(Event evt) {
/*		if ((evt.target == this) && (evt.id == Event.WINDOW_DESTROY)) {
			finished = true;
			hide();
			dispose();
		}*/
		if (evt.target == OKBut) {
			result = RES_OK;
			finished = true;
			hide();
			dispose();
		}
		else if (evt.target == cancelBut) {
			result = RES_CANCEL;
			finished = true;
			hide();
			dispose();
		}
		else if (evt.id == Event.ACTION_EVENT && evt.target == browseButton)
			return onBrowseClick(evt);
		else if (evt.id == Event.ACTION_EVENT && evt.target == checkPackage)
			return onPackageClick(evt);
		else if (evt.id == Event.ACTION_EVENT && evt.target == checkPath)
			return onPathClick(evt);
		else if (evt.id == Event.ACTION_EVENT && evt.target == checkURL)
			return onURLClick(evt);
		return super.handleEvent(evt);
	}

	public boolean onBrowseClick(Event evt) {
		return false;
	}

	public boolean onPackageClick(Event evt) {
		updateHidden();
		return false;
	}

	public boolean onPathClick(Event evt) {
		updateHidden();
		return false;
	}

	public boolean onURLClick(Event evt) {
		updateHidden();
		return false;
	}

	public void setData(XFImageName aIName) {
		iname = aIName;
		switch (iname.getType()) {
			case XFImageName.IN_URL :checkURL.setState(true); break;
			case XFImageName.IN_PATH :checkPath.setState(true); break;
			case XFImageName.IN_PACKAGE :checkPackage.setState(true); break;
		}
		textField1.setText(iname.getText1());
		textField2.setText(iname.getText2());
		updateHidden();
	}

	public XFImageName getData() {
		if (checkURL.getState())
			iname.setURL(textField1.getText());
		else if (checkPath.getState())
			iname.setPath(textField1.getText());
		else if (checkPackage.getState())
			iname.setPackage(textField1.getText(), textField2.getText());
		return iname;
	}
		
	private void updateHidden() {
		if (checkURL.getState()) {
			label1.setText("URL");
			browseButton.hide();
			label2.hide();
			textField2.hide();
		}
		else if (checkPath.getState()) {
			label1.setText("Path");
			browseButton.show();
			label2.hide();
			textField2.hide();
		}
		else if (checkPackage.getState()) {
			label1.setText("Package");
			browseButton.hide();
			label2.show();
			textField2.show();
		}
	}
}
