/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.awt.ColorGrid;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XColorGrid extends XAWTPanel {
	private ColorGrid colGrid;

	private static int propertyCount = 10;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 3;
	private String events[] = new String[eventCount];
	protected static Image icon = null;
	
	public XColorGrid() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		autoSize = true;
		setComponent(colGrid = new ColorGrid());
		propDef = new Object[propertyCount];
		colGrid.propagate = true;
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("colorgrid.gif");
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.ColorGrid";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return (((Integer) propDef[i]).intValue() == colGrid.getGridOrdering());
			case 1: return (((Boolean) propDef[i]).booleanValue() == colGrid.isEnabled());
			case 2: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 3: return (colGrid.defaultBorderColor.equals(colGrid.getBorderColor()));
			case 4: return (colGrid.defaultBorderWidth == colGrid.getBorderWidth());
			case 5: return (((Boolean) propDef[i]).booleanValue() == colGrid.fgIsEnable());
			case 6: return (colGrid.defaultfgCol == colGrid.getFg());
			case 7: return (((Boolean) propDef[i]).booleanValue() == colGrid.bgIsEnable());
			case 8: return (colGrid.defaultbgCol == colGrid.getBg());
			case 9: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;

		propDef[0] = new Integer(colGrid.defaultGridOrdering);
		propDef[1] = new Boolean(colGrid.isEnabled());
		propDef[2] = new Boolean(bVisible);
		propDef[3] = colGrid.defaultBorderColor;
		propDef[4] = new Integer(colGrid.defaultBorderWidth);
		propDef[5] = new Boolean(colGrid.fgIsEnable());
		propDef[6] = new Integer(colGrid.defaultfgCol);
		propDef[7] = new Boolean(colGrid.bgIsEnable());
		propDef[8] = new Integer(colGrid.defaultbgCol);
		propDef[9] = new Boolean(autoSize);
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return new Integer(colGrid.getGridOrdering());
			case 1: return (colGrid.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 2: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return colGrid.getBorderColor();
			case 4: return new Integer(colGrid.getBorderWidth());
			case 5: return (colGrid.fgIsEnable()) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return new Integer(colGrid.getFg());
			case 7: return (colGrid.bgIsEnable()) ? Boolean.TRUE : Boolean.FALSE;
			case 8: return new Integer(colGrid.getBg());
			case 9: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Grid Ordering";
		list[1] = "Enabled";
		list[2] = "Visible";
		list[3] = "Border Color";
		list[4] = "Border Width";
		list[5] = "Foreground enable";
		list[6] = "Foreground color";
		list[7] = "Background enable";
		list[8] = "Background color";
		list[9] = "Auto Size";

		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {

			case 1:
			case 2: return XBooleanPropertyType.viewString(getProperty(index));
			case 3: return XColorPropertyType.viewString(getProperty(index));
			case 4: return XIntegerPropertyType.viewString(getProperty(index));
			case 5: return XBooleanPropertyType.viewString(getProperty(index));
			case 6: return XIntegerPropertyType.viewString(getProperty(index));
			case 7: return XBooleanPropertyType.viewString(getProperty(index));
			case 8: return XIntegerPropertyType.viewString(getProperty(index));
			case 9: return XBooleanPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: return XFDesignConstants.PVT_CHOICE_STRICT;
			case 1:
			case 2: return XFDesignConstants.PVT_CHECK;
			case 3: return XFDesignConstants.PVT_SPECIAL;
			case 4: return XFDesignConstants.PVT_INPUT_INT;
			case 5: return XFDesignConstants.PVT_CHECK;
			case 6: return XFDesignConstants.PVT_INPUT_INT;
			case 7: return XFDesignConstants.PVT_CHECK;
			case 8: return XFDesignConstants.PVT_INPUT_INT;
			case 9: return XFDesignConstants.PVT_CHECK;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: String[] ret = new String[5];
					ret[0] = " 1 x 16";
					ret[1] = " 2 x 8";
					ret[2] = " 4 x 4";
					ret[3] = " 8 x 2";
					ret[4] = "16 x 1";
					return ret;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: Integer[] ret = new Integer[5];
					ret[0] = new Integer(ColorGrid.GO_1x16);
					ret[1] = new Integer(ColorGrid.GO_2x8);
					ret[2] = new Integer(ColorGrid.GO_4x4);
					ret[3] = new Integer(ColorGrid.GO_8x2);
					ret[4] = new Integer(ColorGrid.GO_16x1);
					return ret;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					colGrid.setGridOrdering(((Integer)value).intValue());
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					colGrid.repaint();
					break;					
			case 1:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					colGrid.enable(((Boolean)value).booleanValue());
					break;
			case 2: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 3:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					colGrid.setBorderColor((Color)value);
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					colGrid.repaint();
					break;
			case 4:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					colGrid.setBorderWidth(((Integer)value).intValue());
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					colGrid.repaint();
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					colGrid.fgEnable(((Boolean)value).booleanValue());
					break;
			case 6:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					try {
						colGrid.setFg(((Integer)value).intValue());
					}
					catch (ArrayIndexOutOfBoundsException e) {
						System.out.println("Index out of bounds.");
					}
					break;
			case 7:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					colGrid.bgEnable(((Boolean)value).booleanValue());
					break;
			case 8:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					try {
						colGrid.setBg(((Integer)value).intValue());
					}
					catch (ArrayIndexOutOfBoundsException e) {
						System.out.println("Index out of bounds.");
					}
					break;
			case 9:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						colGrid.repaint();
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 3: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		list[2] = "OnSelectChange";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "ColorGrid";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: gen = gen + name + ".setGridOrdering(ColorGrid.GO_";
									switch (colGrid.getGridOrdering()) {
										case ColorGrid.GO_1x16: gen = gen + "1x16"; break;
										case ColorGrid.GO_2x8: gen = gen + "2x8"; break;
										case ColorGrid.GO_4x4: gen = gen + "4x4"; break;
										case ColorGrid.GO_8x2: gen = gen + "8x2"; break;
										case ColorGrid.GO_16x1: gen = gen + "16x1"; break;
									}
									gen = gen + ");\n";
									break;
							case 1: gen = gen + name + (colGrid.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 2: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 3: gen = gen + name + ".setBorderColor(" +
										XFDesignUtils.genColor(colGrid.getBorderColor()) + ");\n";
									break;
							case 4: gen = gen + name + ".setBorderWidth(" + colGrid.getBorderWidth() + ");\n";
									break;
							case 5: gen = gen + name + ".fgEnable(" + (colGrid.fgIsEnable() ? "true" : "false") + ");\n";
									break;
							case 6: gen = gen + name + ".setFg(" + colGrid.getFg() + ");\n";
									break;
							case 7: gen = gen + name + ".bgEnable(" + (colGrid.bgIsEnable() ? "true" : "false") + ");\n";
									break;
							case 8: gen = gen + name + ".setBg(" + colGrid.getBg() + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			case 2: return evt +".id == ColorGrid.COL_GRID_CHANGE && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		if (XFDesignOptions.designMode == XFDesignConstants.DM_REAL)
			colGrid.propagate = false;
		else
			colGrid.propagate = true;
		return super.handleEvent(evt);
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: colGrid.setGridOrdering(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 1: colGrid.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 2: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 3: colGrid.setBorderColor(XColorPropertyType.loadFromStream(stream)); break;
				case 4: colGrid.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 5: colGrid.fgEnable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: colGrid.setFg(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 7: colGrid.bgEnable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 8: colGrid.setBg(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 9: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XIntegerPropertyType.saveToStream(new Integer(colGrid.getGridOrdering()), stream); break;
					case 1: XBooleanPropertyType.saveToStream(colGrid.isEnabled(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 3: XColorPropertyType.saveToStream(colGrid.getBorderColor(), stream); break;
					case 4: XIntegerPropertyType.saveToStream(new Integer(colGrid.getBorderWidth()), stream); break;
					case 5: XBooleanPropertyType.saveToStream(colGrid.fgIsEnable(), stream); break;
					case 6: XIntegerPropertyType.saveToStream(new Integer(colGrid.getFg()), stream); break;
					case 7: XBooleanPropertyType.saveToStream(colGrid.bgIsEnable(), stream); break;
					case 8: XIntegerPropertyType.saveToStream(new Integer(colGrid.getBg()), stream); break;
					case 9: XBooleanPropertyType.saveToStream(autoSize, stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}