/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.awt.TabControl;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XTabControl extends XAWTPanel {
	private TabControl tabcontrol;

	private static int propertyCount = 14;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 3;
	private String events[] = new String[eventCount];
	protected static Image icon = null;
	
	public XTabControl() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		setComponent(tabcontrol = new TabControl());
		tabcontrol.propagate = true;
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("tabcontrol.gif");
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.TabControl";
		return ret;
	}

	public Dimension preferredSize() {

		Dimension sz = super.preferredSize();
		if ((tabcontrol.getTabCount() == 0) && 
			(XFDesignOptions.designMode == XFDesignConstants.DM_DESIGN)) {
			sz.width += 40;
		}
		return sz;
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		if (XFDesignOptions.designMode == XFDesignConstants.DM_REAL)
			tabcontrol.propagate = false;
		else
			tabcontrol.propagate = true;
		return super.handleEvent(evt);
	}

	public Image getIcon() {
		return icon; 
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return ((Color) propDef[i]).equals(tabcontrol.getBackground());
			case 1: return ((Color) propDef[i]).equals(tabcontrol.getForeground());
			case 2: return (((Boolean) propDef[i]).booleanValue() == tabcontrol.isEnabled());
			case 3: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 4: return ((Font) propDef[i]).equals(tabcontrol.getFont());
			case 5: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			case 6: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			case 7: return (((Boolean) propDef[i]).booleanValue() == parentFont);
			case 8: return false;
			case 9: return (((Integer) propDef[i]).intValue() == tabcontrol.getTabIndex());
			case 10: return (tabcontrol.defaultMinWidth == tabcontrol.getMinWidth());
			case 11: return (tabcontrol.defaultBorderColor.equals(tabcontrol.getBorderColor()));
			case 12: return (tabcontrol.defaultBorderWidth == tabcontrol.getBorderWidth());
			case 13: return (tabcontrol.defaultDirection == tabcontrol.getDirection());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;
		if (getBackground() != null)
				propDef[0] = new Color(tabcontrol.getBackground().getRGB());
		if (getForeground() != null)
				propDef[1] = new Color(tabcontrol.getForeground().getRGB());
		propDef[2] = new Boolean(tabcontrol.isEnabled());
		propDef[3] = new Boolean(bVisible);
		if (tabcontrol.getFont() != null) {
			Font f = tabcontrol.getFont();
			propDef[4] = new Font(f.getName(), f.getStyle(), f.getSize());
		}
		propDef[5] = new Boolean(autoSize);
		propDef[6] = new Boolean(parentColor);
		propDef[7] = new Boolean(parentFont);
		propDef[8] = new String[1];
		propDef[9] = new Integer(-1);
		propDef[10] = new Integer(tabcontrol.defaultMinWidth);
		propDef[11] = tabcontrol.defaultBorderColor;
		propDef[12] = new Integer(tabcontrol.defaultBorderWidth);
		propDef[13] = new Boolean(tabcontrol.defaultDirection);
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return tabcontrol.getBackground();
			case 1: return tabcontrol.getForeground();
			case 2: return (tabcontrol.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 4: return tabcontrol.getFont();
			case 5: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			case 7: return (parentFont) ? Boolean.TRUE : Boolean.FALSE;
			case 8: int cnt = tabcontrol.getTabCount();
					String[] ret = new String[cnt];
					for (int i = 0; i < cnt; i++)
						ret[i] = tabcontrol.getTabName(i);
					return ret;
			case 9: return new Integer(tabcontrol.getTabIndex());
			case 10: return new Integer(tabcontrol.getMinWidth());
			case 11: return tabcontrol.getBorderColor();
			case 12: return new Integer(tabcontrol.getBorderWidth());
			case 13: return new Boolean(tabcontrol.getDirection());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Background Color";
		list[1] = "Foreground Color";
		list[2] = "Enabled";
		list[3] = "Visible";
		list[4] = "Font";
		list[5] = "Auto Size";
		list[6] = "Parent Color";
		list[7] = "Parent Font";
		list[8] = "Tabs";
		list[9] = "Selected";
		list[10] = "Minimal Width";
		list[11] = "Border Color";
		list[12] = "Border Width";
		list[13] = "Direction";
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: 
			case 1: return XColorPropertyType.viewString(getProperty(index));
			case 2:
			case 3: return XBooleanPropertyType.viewString(getProperty(index));
			case 4: return XFontPropertyType.viewString(getProperty(index));
			case 5: 
			case 6: 
			case 7: return XBooleanPropertyType.viewString(getProperty(index));
			case 8: return XStringArrayPropertyType.viewString(getProperty(index));
			case 9: return XIntegerPropertyType.viewString(getProperty(index));
			case 10: return XIntegerPropertyType.viewString(getProperty(index));
			case 11: return XColorPropertyType.viewString(getProperty(index));
			case 12: return XIntegerPropertyType.viewString(getProperty(index));
			case 13: return XBooleanPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: return XFDesignConstants.PVT_SPECIAL;
			case 2:
			case 3: return XFDesignConstants.PVT_CHECK;
			case 4: return XFDesignConstants.PVT_SPECIAL;
			case 5: 
			case 6: 
			case 7: return XFDesignConstants.PVT_CHECK;
			case 8: return XFDesignConstants.PVT_SPECIAL;
			case 9: return XFDesignConstants.PVT_INPUT_INT;
			case 10: return XFDesignConstants.PVT_INPUT_INT;
			case 11: return XFDesignConstants.PVT_SPECIAL;
			case 12: return XFDesignConstants.PVT_INPUT_INT;
			case 13: return XFDesignConstants.PVT_CHECK;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0: if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					tabcontrol.setBackground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					tabcontrol.repaint();
					break;
			case 1:	if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					tabcontrol.setForeground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					tabcontrol.repaint();
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					tabcontrol.enable(((Boolean)value).booleanValue());
					break;
			case 3: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 4: if (!(value instanceof Font)) throw new XFPropertyBadValueTypeException();
					tabcontrol.setFont((Font)value); 
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP | XFDesignConstants.RSP_OTHER_PROP;
					if (parentFont) {
						parentFont = false;
						if (autoSize) {
							setDesignSize(0,0);
							regen = regen | XFDesignConstants.GEN_RESHAPE;
							repaintComponent();
						}
					}
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						tabcontrol.repaint();
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 6:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 7: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentFont(((Boolean)value).booleanValue());
					if (parentFont)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize)
					 	ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 8: if (!(value instanceof String[])) throw new XFPropertyBadValueTypeException();
					tabcontrol.removeAllTabs();
					for (int i = 0; i < ((String [])value).length; i++)
						tabcontrol.addTab(((String [])value)[i]);
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						repaintComponent();
					}
					break;
			case 9: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					try {
						int newValue = ((Integer)value).intValue();
						tabcontrol.setTabIndex(newValue);
						tabcontrol.setVisible(newValue);
						repaintComponent();
					}
					catch (ArrayIndexOutOfBoundsException e) {
						System.out.println("Array Index Out Of Bounds Exception");					
					}	
					break;
			case 10:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tabcontrol.setMinWidth(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						repaintComponent();
					}
					break;
			case 11:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					tabcontrol.setBorderColor((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 12:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					tabcontrol.setBorderWidth(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						repaintComponent();
					}
					break;
			case 13:if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					tabcontrol.setDirection(((Boolean)value).booleanValue());
					if (autoSize)
					 	ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 0:
			case 1: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			case 4: XFontPropertyType.invokeSpecialInput(parent, this, index);
					break;
			case 8: XStringArrayPropertyType.invokeSpecialInput(parent, this, index);
					break;
			case 11: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnChangeTab";
		list[1] = "OnGotFocus";
		list[2] = "OnLostFocus";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "TabControl";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(tabcontrol.getBackground()) + ");\n";
									break;
							case 1: if (!parentColor)
										gen = gen + name + ".setForeground(" +
											XFDesignUtils.genColor(tabcontrol.getForeground()) + ");\n";
									break;
							case 2: gen = gen + name + (tabcontrol.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 3: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 4: if (!parentFont) {
										gen = gen + name + ".setFont(" + 
											XFDesignUtils.genFont(tabcontrol.getFont())+");\n";
									}
									break;
							case 8: for (int j = 0; j < tabcontrol.getTabCount(); j++)
										gen = gen + name + ".addTab(\"" + tabcontrol.getTabName(j) + "\");\n";
									break;
							case 9: gen = gen + name + ".setTabIndex(" + tabcontrol.getTabIndex() + ");\n";
									break;
							case 10: gen = gen + name + ".setMinWidth(" + tabcontrol.getMinWidth() + ");\n";
									break;
							case 11: gen = gen + name + ".setBorderColor(" +
										XFDesignUtils.genColor(tabcontrol.getBorderColor()) + ");\n";
									break;
							case 12: gen = gen + name + ".setBorderWidth(" + tabcontrol.getBorderWidth() + ");\n";
									break;
							case 13: gen = gen + name + ".setDirection(" + (tabcontrol.getDirection() ? "true" : "false") + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == TabControl.TAB_CHANGE && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 2: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: tabcontrol.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 1: tabcontrol.setForeground(XColorPropertyType.loadFromStream(stream)); break;
				case 2: tabcontrol.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 4: tabcontrol.setFont(XFontPropertyType.loadFromStream(stream)); break;
				case 5: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 7: setParentFont(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 8: String[] str = (XStringArrayPropertyType.loadFromStream(stream));
						for (int j = 0; j < str.length; j++) 
							tabcontrol.addTab(str[j]);
						break;
				case 9: tabcontrol.setTabIndex(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 10: tabcontrol.setMinWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 11: tabcontrol.setBorderColor(XColorPropertyType.loadFromStream(stream)); break;
				case 12: tabcontrol.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 13: tabcontrol.setDirection(XBooleanPropertyType.loadBFromStream(stream)); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XColorPropertyType.saveToStream(tabcontrol.getBackground(), stream); break;
					case 1: XColorPropertyType.saveToStream(tabcontrol.getForeground(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(tabcontrol.isEnabled(), stream); break;
					case 3: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 4: XFontPropertyType.saveToStream(tabcontrol.getFont(), stream); break;
					case 5: XBooleanPropertyType.saveToStream(autoSize, stream); break;
					case 6: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 7: XBooleanPropertyType.saveToStream(parentFont, stream); break;
					case 8: String[] str = new String[tabcontrol.getTabCount()];
							for (int j = 0; j < tabcontrol.getTabCount(); j++)
								str[j] = tabcontrol.getTabName(j);
							XStringArrayPropertyType.saveToStream(str, stream);
							break;
					case 9: XIntegerPropertyType.saveToStream(new Integer(tabcontrol.getTabIndex()), stream); break;
					case 10: XIntegerPropertyType.saveToStream(new Integer(tabcontrol.getMinWidth()), stream); break;
					case 11: XColorPropertyType.saveToStream(tabcontrol.getBorderColor(), stream); break;
					case 12: XIntegerPropertyType.saveToStream(new Integer(tabcontrol.getBorderWidth()), stream); break;
					case 13: XBooleanPropertyType.saveToStream(tabcontrol.getDirection(), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}