/**
* Xelfi
*/

package xelfi.design.util;

import java.awt.*;
import xelfi.design.components.XelfiVisualContainer;

/**
 * @version 	1.03, 06 Apr 1997
 * @author 	Ian Formanek
 */

class GridThread extends Thread {
	XelfiVisualContainer gridParent;
	Container gridCont;
	int iw, ih;
	GridInfo gridIn;
	public GridThread(XelfiVisualContainer aGridParent, GridInfo aGridIn) {
		super("GridThread");		
		gridParent = aGridParent;
		gridCont = (Container) gridParent;
		gridIn = aGridIn;
		Dimension size = gridCont.size();
		iw = size.width; ih = size.height;
	}

	public GridThread(XelfiVisualContainer aGridParent, GridInfo aGridIn, int w, int h) {
		super("GridThread");		
		gridParent = aGridParent;
		gridCont = (Container) gridParent;
		gridIn = aGridIn;
		iw = w; ih = h;
	}

	public void run() {
		Image im = gridCont.createImage(iw, ih);
		Graphics ig = im.getGraphics();
		ig.setColor(gridCont.getBackground());
		ig.drawRect(0, 0, iw, ih);
		ig.setColor(gridCont.getForeground());
		for (int j=0; j< ih; j+= gridIn.gridY())
			for (int i=0; i< iw; i+= gridIn.gridX())
				ig.drawLine(i,j,i,j);
		gridIn.gridImage = im;
		gridIn.imWidth = iw;
		gridIn.imHeight = ih;
		gridCont.repaint();
	}
}