/**
* Xelfi Environment
*/

package xelfi.editor;

/** Class that implements this inteface can be notifed before
* any modification in editor is done and it is sure that it will
* take place.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public interface ActionPreListener {
  /** Called before insert.
  * @param p position of insert
  * @param s string to insert
  */
  public void beforeInsert (Position p, String s);

  /** Called before delete of single character.
  * @param p position of delete
  */
  public void beforeDelete (Position p);

  /** Called before delete of block.
  * @param from first position of delete
  * @param to last position (it will not be deleted)
  */
  public void beforeMultiDelete (Position from, Position to);
}




// Generated from substitution template 'Interface' Blocks:Class:17,13,34,13; Package:8,4,20,4; 
