/**
* Xelfi Environment
*/

package xelfi.editor;

/** Provides non trivial operations on the document.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public class EditorOperation extends Object {
  /** Finds a string in the document.
  * @param p position where to start search
  * @param s string to find
  * @param caseSensitive case sensitive
  * @param forward direction
  * @return the position. If forward than this position is after the word
  *           if backward then it is before the word
  * @exception EndOfTextException nothing is found
  */
  public static Position findWord (
    Position p, String s, boolean caseSensitive, boolean forward
  ) throws EndOfTextException {
    if (!forward) {
      int len;
      StringBuffer x = new StringBuffer (len = s.length ());
      while (--len >= 0) {
        x.append (s.charAt (len));
      };
      s = x.toString ();
    };

    AcceptorFind af = new AcceptorFind (s, caseSensitive);
    Position r = p.find (af, forward);
    return forward ? r.next () : r;
  };
}




// Generated from substitution template 'Class' Blocks:Class:13,11,28,11; Package:8,4,20,4; 
