/**
* Xelfi Environment
*/

package xelfi.editor;

/** Redraw Listener enables implementors to be informed about special
* actions that causes some redrawing.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public interface RedrawListener {
  /** This method is called when anybody asks for block redrawing.
  * @param b the block to redraw
  */
  public void redrawBlock (Block b);

  /** This method informs about request to lock redrawing.
  * Locking is useful when complex modification of text are done.
  * @param d the document
  */
  public void redrawLock (Document d);

  /** This method informs about request to unlock redrawing.
  * This should be called after lock to release it.
  * @param d the document
  */
  public void redrawUnlock (Document d);
}



// Generated from substitution template 'XelfiInterface' Blocks:Class:17,12,31,12; Package:8,4,20,4; 
