/**
* Xelfi Environment
*/

package xelfi.editor.actions;
import xelfi.editor.*;
import xelfi.editor.keys.*;
import java.util.Vector;

/** Inserts text that is passed as parameter.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public class InsertText extends Object implements KeyActionHandler {
  private String text;
  
  /** Initialize the object.
  * @param v vector of parameters. It can contain objects of type
  *   String, Integer, Character.
  * @exception IllegalArgumentException if a parameter is not valid
  */
  public void init (Vector v) {
    if (v.size () == 1) {
      try {
        text = (String)v.elementAt (0);
        return;
      } catch (Exception ex) {
      };
    };
    throw new IllegalArgumentException ("InsertText needs one string parameter");
  };

  /** Inserts the key to the editor.
  * @param key the key code that occured
  * @param modifiers the state of modifiers
  * @param info info about editor
  * @return true if next command should be excecuted, false if
  *   the action should stop
  * @exception NotAllowedException if the action is not allowed
  */
  public boolean keyDown (int key, int modifiers, TextEditorInfo info)
  throws NotAllowedException {
    info.getCursorPos ().insert (text);
    return true;
  };
}

