package xelfi.editor.keys;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import java.io.StringBufferInputStream;
import java.io.InputStream;

public class KeyConfigTokenManager implements KeyConfigConstants
{
  protected static final String jjadd_escapes(String str) {
    String retval = "";
    char ch;
    for (int i = 0; i < str.length(); i++) {
      if ((ch = str.charAt(i)) == 0) continue;
      if (ch == '\b') {
        retval += "\\b";
      } else if (ch == '\t') {
        retval += "\\t";
      } else if (ch == '\n') {
        retval += "\\n";
      } else if (ch == '\f') {
        retval += "\\f";
      } else if (ch == '\r') {
        retval += "\\r";
      } else if (ch == '\"') {
        retval += "\\\"";
      } else if (ch == '\'') {
        retval += "\\\'";
      } else if (ch == '\\') {
        retval += "\\\\";
      } else if (ch < 0x20 || ch > 0x7e) {
        String s = "0000" + Integer.toString(ch, 16);
        retval += "\\u" + s.substring(s.length() - 4, s.length());
      } else {
        retval += ch;
      }
    }
    return retval;
  }

static final long[] jjbitVec0 = { 0xfffffffffffffffeL, 0xffffffffffffffffL,
              0xffffffffffffffffL, 0xffffffffffffffffL };
static final long[] jjbitVec2 = { 0x1L, 0x0L,
              0xffffffffffffffffL, 0xffffffffffffffffL };
static final long[] jjbitVec3 = { 0x1ff00000fffffffeL, 0xffffffffffffc000L,
              0xffffffffL, 0x600000000000000L };
static final long[] jjbitVec4 = { 0x1L, 0x0L,
              0x0L, 0xff7fffffff7fffffL };
static final long[] jjbitVec5 = { 0x0L, 0xffffffffffffffffL,
              0xffffffffffffffffL, 0xffffffffffffffffL };
static final long[] jjbitVec6 = { 0xffffffffffffffffL, 0xffffffffffffffffL,
              0xffffL, 0x0L };
static final long[] jjbitVec7 = { 0xffffffffffffffffL, 0xffffffffffffffffL,
              0x0L, 0x0L };
static final long[] jjbitVec8 = { 0x3fffffffffffL, 0x0L,
              0x0L, 0x0L };
static private final void jjMoveNfa_0(int[] oldStates, int[] newStates)
{
   int j, k;
   MainLoop :
   for (;;)
   {
      if (curChar < 64)
      {
         int i = jjnewStateCnt;
         jjnewStateCnt = 0;
         jjround++;
         long l = 1L << curChar;
         do
         {
            switch(oldStates[--i])
            {
               case (25) :
                  if ((0x800000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates15;
                     break;
                  }
                  else continue;
               case (26) :
                  if ((0xffffffffffffdbffL & l) != 0L)
                  {
                     jjnextStates = jjstates15;
                     break;
                  }
                  else continue;
               case (27) :
                  if ((0x2400L & l) != 0L)
                  {
                     if (jjcurKind > 6)
                        jjcurKind = 6;
                     continue;
                  }
                  else continue;
               case (29) :
                  if ((0x2000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 28;
                     jjnewStateCnt += 1;
                     continue;
                  }
                  else continue;
               case (28) :
                  if ((0x400L & l) != 0L)
                  {
                     if (jjcurKind > 6)
                        jjcurKind = 6;
                     continue;
                  }
                  else continue;
               case (36) :
                  if ((0x40000000000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 30;
                     jjnewStateCnt += 1;
                     continue;
                  }
                  else continue;
               case (30) :
                  if ((0x40000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates18;
                     break;
                  }
                  else continue;
               case (31) :
                  if ((0xfffffbffffffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates18;
                     break;
                  }
                  else continue;
               case (32) :
                  if ((0x40000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates17;
                     break;
                  }
                  else continue;
               case (33) :
                  if ((0xffff7bffffffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates16;
                     break;
                  }
                  else continue;
               case (34) :
                  if ((0xfffffbffffffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates16;
                     break;
                  }
                  else continue;
               case (35) :
                  if ((0x800000000000L & l) != 0L)
                  {
                     if (jjcurKind > 7)
                        jjcurKind = 7;
                     continue;
                  }
                  else continue;
               case (37) :
                  if ((0x40000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates22;
                     break;
                  }
                  else continue;
               case (38) :
                  if ((0xfffffbffffffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates22;
                     break;
                  }
                  else continue;
               case (39) :
                  if ((0x40000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates21;
                     break;
                  }
                  else continue;
               case (40) :
                  if ((0xffff7bffffffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates20;
                     break;
                  }
                  else continue;
               case (41) :
                  if ((0xfffffbffffffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates20;
                     break;
                  }
                  else continue;
               case (42) :
                  if ((0x800000000000L & l) != 0L)
                  {
                     if (jjcurKind > 8)
                        jjcurKind = 8;
                     continue;
                  }
                  else continue;
               case (1) :
                  if ((0xfffffffeffffdbffL & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 1;
                     newStates[jjnewStateCnt + 1] = 2;
                     jjnewStateCnt += 2;
                     continue;
                  }
                  else continue;
               case (3) :
                  if ((0x3ff000000000000L & l) != 0L)
                  {
                     if (jjcurKind > 19)
                        jjcurKind = 19;
                     newStates[jjnewStateCnt + 0] = 3;
                     jjnewStateCnt += 1;
                     continue;
                  }
                  else continue;
               case (4) :
                  if ((0x8000000000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 5;
                     newStates[jjnewStateCnt + 1] = 7;
                     jjnewStateCnt += 2;
                     continue;
                  }
                  else continue;
               case (5) :
                  if ((0xffffff7fffffdbffL & l) != 0L)
                  {
                     jjnextStates = jjstates2;
                     break;
                  }
                  else continue;
               case (8) :
                  if ((0x8400000000L & l) != 0L)
                  {
                     jjnextStates = jjstates2;
                     break;
                  }
                  else continue;
               case (9) :
                  if ((0xff000000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates3;
                     break;
                  }
                  else continue;
               case (10) :
                  if ((0xff000000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates2;
                     break;
                  }
                  else continue;
               case (11) :
                  if ((0xf000000000000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 12;
                     jjnewStateCnt += 1;
                     continue;
                  }
                  else continue;
               case (12) :
                  if ((0xff000000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates4;
                     break;
                  }
                  else continue;
               case (6) :
                  if ((0x8000000000L & l) != 0L)
                  {
                     if (jjcurKind > 20)
                        jjcurKind = 20;
                     continue;
                  }
                  else continue;
               case (13) :
                  if ((0x400000000L & l) != 0L)
                  {
                     jjnextStates = jjstates8;
                     break;
                  }
                  else continue;
               case (14) :
                  if ((0xfffffffbffffdbffL & l) != 0L)
                  {
                     jjnextStates = jjstates8;
                     break;
                  }
                  else continue;
               case (16) :
                  if ((0x8400000000L & l) != 0L)
                  {
                     jjnextStates = jjstates8;
                     break;
                  }
                  else continue;
               case (18) :
                  if ((0xff000000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates9;
                     break;
                  }
                  else continue;
               case (19) :
                  if ((0xff000000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates8;
                     break;
                  }
                  else continue;
               case (20) :
                  if ((0xf000000000000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 21;
                     jjnewStateCnt += 1;
                     continue;
                  }
                  else continue;
               case (21) :
                  if ((0xff000000000000L & l) != 0L)
                  {
                     jjnextStates = jjstates10;
                     break;
                  }
                  else continue;
               case (17) :
                  if ((0x400000000L & l) != 0L)
                  {
                     if (jjcurKind > 21)
                        jjcurKind = 21;
                     continue;
                  }
                  else continue;
               case (22) :
                  if ((0x1000000000L & l) != 0L)
                  {
                     if (jjcurKind > 22)
                        jjcurKind = 22;
                     jjnextStates = jjstates13;
                     break;
                  }
                  else continue;
               case (23) :
                  if ((0x3ff001000000000L & l) != 0L)
                  {
                     if (jjcurKind > 22)
                        jjcurKind = 22;
                     jjnextStates = jjstates13;
                     break;
                  }
                  else continue;
               case (24) :
                  if ((0x800000000000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 25;
                     newStates[jjnewStateCnt + 1] = 36;
                     newStates[jjnewStateCnt + 2] = 37;
                     jjnewStateCnt += 3;
                     continue;
                  }
                  else continue;
               default : continue;
            }
            j = jjnextStates.length;
            do
            {
               if (jjrounds[k = jjnextStates[--j]] != jjround)
               {
                  jjrounds[k] = jjround;
                  newStates[jjnewStateCnt++] = k;
               }
            } while (j != 0);
         } while(i != 0);
      }
      else if (curChar < 128)
      {
         int i = jjnewStateCnt;
         jjnewStateCnt = 0;
         jjround++;
         long l = 1L << (curChar & 077);
         do
         {
            switch(oldStates[--i])
            {
               case (26) :
                     newStates[jjnewStateCnt + 0] = 26;
                     newStates[jjnewStateCnt + 1] = 27;
                     newStates[jjnewStateCnt + 2] = 29;
                     jjnewStateCnt += 3;
                     continue;
               case (31) :
                     jjnextStates = jjstates18;
                     break;
               case (33) :
                     jjnextStates = jjstates16;
                     break;
               case (34) :
                     jjnextStates = jjstates16;
                     break;
               case (38) :
                     jjnextStates = jjstates22;
                     break;
               case (40) :
                     jjnextStates = jjstates20;
                     break;
               case (41) :
                     jjnextStates = jjstates20;
                     break;
               case (0) :
                  if ((0x8000000L & l) != 0L)
                  {
                     jjnextStates = jjstates0;
                     break;
                  }
                  else continue;
               case (1) :
                  if ((0xffffffffd7ffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates0;
                     break;
                  }
                  else continue;
               case (2) :
                  if ((0x20000000L & l) != 0L)
                  {
                     if (jjcurKind > 18)
                        jjcurKind = 18;
                     continue;
                  }
                  else continue;
               case (5) :
                  if ((0xffffffffefffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates2;
                     break;
                  }
                  else continue;
               case (7) :
                  if ((0x10000000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 8;
                     newStates[jjnewStateCnt + 1] = 9;
                     newStates[jjnewStateCnt + 2] = 11;
                     jjnewStateCnt += 3;
                     continue;
                  }
                  else continue;
               case (8) :
                  if ((0x14404410000000L & l) != 0L)
                  {
                     jjnextStates = jjstates2;
                     break;
                  }
                  else continue;
               case (14) :
                  if ((0xffffffffefffffffL & l) != 0L)
                  {
                     jjnextStates = jjstates8;
                     break;
                  }
                  else continue;
               case (15) :
                  if ((0x10000000L & l) != 0L)
                  {
                     newStates[jjnewStateCnt + 0] = 16;
                     newStates[jjnewStateCnt + 1] = 18;
                     newStates[jjnewStateCnt + 2] = 20;
                     jjnewStateCnt += 3;
                     continue;
                  }
                  else continue;
               case (16) :
                  if ((0x14404410000000L & l) != 0L)
                  {
                     jjnextStates = jjstates8;
                     break;
                  }
                  else continue;
               case (22) :
                  if ((0x7fffffe87fffffeL & l) != 0L)
                  {
                     if (jjcurKind > 22)
                        jjcurKind = 22;
                     jjnextStates = jjstates13;
                     break;
                  }
                  else continue;
               case (23) :
                  if ((0x7fffffe87fffffeL & l) != 0L)
                  {
                     if (jjcurKind > 22)
                        jjcurKind = 22;
                     jjnextStates = jjstates13;
                     break;
                  }
                  else continue;
               default : continue;
            }
            j = jjnextStates.length;
            do
            {
               if (jjrounds[k = jjnextStates[--j]] != jjround)
               {
                  jjrounds[k] = jjround;
                  newStates[jjnewStateCnt++] = k;
               }
            } while (j != 0);
         } while(i != 0);
      }
      else
      {
         int i = jjnewStateCnt;
         jjnewStateCnt = 0;
         jjround++;
         int i2 = (curChar & 0xff) >> 6;
         int i1 = ((curChar >> 8) & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         long l1 = 1L << ((curChar >> 8) & 077);
         Outer:
         do
         {
            switch(oldStates[--i])
            {
               case (26) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     newStates[jjnewStateCnt + 0] = 26;
                     newStates[jjnewStateCnt + 1] = 27;
                     newStates[jjnewStateCnt + 2] = 29;
                     jjnewStateCnt += 3;
                     continue;
               case (31) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     jjnextStates = jjstates18;
                     break;
               case (33) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     jjnextStates = jjstates16;
                     break;
               case (34) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     jjnextStates = jjstates16;
                     break;
               case (38) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     jjnextStates = jjstates22;
                     break;
               case (40) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     jjnextStates = jjstates20;
                     break;
               case (41) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     jjnextStates = jjstates20;
                     break;
               case (1) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     newStates[jjnewStateCnt + 0] = 1;
                     newStates[jjnewStateCnt + 1] = 2;
                     jjnewStateCnt += 2;
                     continue;
               case (5) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     newStates[jjnewStateCnt + 0] = 6;
                     jjnewStateCnt += 1;
                     continue;
               case (14) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec2[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec0[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                     newStates[jjnewStateCnt + 0] = 14;
                     newStates[jjnewStateCnt + 1] = 15;
                     newStates[jjnewStateCnt + 2] = 17;
                     jjnewStateCnt += 3;
                     continue;
               case (22) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec4[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (48):
                           if ((jjbitVec5[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (49):
                           if ((jjbitVec6[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (51):
                           if ((jjbitVec7[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (61):
                           if ((jjbitVec8[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec3[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                  if (jjcurKind > 22)
                     jjcurKind = 22;
                     jjnextStates = jjstates13;
                     break;
               case (23) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec4[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (48):
                           if ((jjbitVec5[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (49):
                           if ((jjbitVec6[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (51):
                           if ((jjbitVec7[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        case (61):
                           if ((jjbitVec8[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     if ((jjbitVec3[i1] & l1) != 0L)
                           break MatchLoop;
                     continue Outer;
                  }
                  if (jjcurKind > 22)
                     jjcurKind = 22;
                     jjnextStates = jjstates13;
                     break;
               default : continue;
            }
            j = jjnextStates.length;
            do
            {
               if (jjrounds[k = jjnextStates[--j]] != jjround)
               {
                  jjrounds[k] = jjround;
                  newStates[jjnewStateCnt++] = k;
               }
            } while (j != 0);
         } while(i != 0);
      }
      return;
   }
}
static void jjStartNfa_0(int pos, long active0)
{
   switch (pos)
   {
      case (0) : 
         curPos = 1;
         break; 
      case (1) :
         curPos = 2;
         if ((active0 & 0xe00L) != 0L)
         {
            matchedToken.kind = 22;
            jjstartStateSet = jjstates13;
            break;
         }
         return;
      case (2) :
         curPos = 3;
         if ((active0 & 0xe00L) != 0L)
         {
            if (jjmatchedPos != 1)
            {
               matchedToken.kind = 22;
               jjmatchedPos = 1;
            }
            jjstartStateSet = jjstates13;
            break;
         }
         return;
      case (3) :
         curPos = 4;
         if ((active0 & 0x800L) != 0L)
         {
            jjstartStateSet = jjstates13;
            break;
         }
         else if ((active0 & 0x600L) != 0L)
         {
            if (jjmatchedPos != 2)
            {
               matchedToken.kind = 22;
               jjmatchedPos = 2;
            }
            jjstartStateSet = jjstates13;
            break;
         }
         return;
      case (4) :
         curPos = 5;
         if ((active0 & 0x600L) != 0L)
         {
            if (jjmatchedPos != 3)
            {
               matchedToken.kind = 22;
               jjmatchedPos = 3;
            }
            jjstartStateSet = jjstates13;
            break;
         }
         return;
      case (5) :
         curPos = 6;
         if ((active0 & 0x200L) != 0L)
         {
            if (jjmatchedPos != 4)
            {
               matchedToken.kind = 22;
               jjmatchedPos = 4;
            }
            jjstartStateSet = jjstates13;
            break;
         }
         else if ((active0 & 0x400L) != 0L)
         {
            jjstartStateSet = jjstates13;
            break;
         }
         return;
      default : 
         curPos = pos + 1;
         return;
   }
   if (jjstartStateSet != null)
   {
      jjnewStateCnt = jjstartStateSet.length;
      jjMoveNfa_0(jjstartStateSet, jjstateSet2);
      if (jjcurKind != 2147483647)
      {
         if (jjmatchedPos != pos)
         {
            matchedToken.kind = jjcurKind;
            jjmatchedPos = pos;
         }
         else if (jjcurKind < matchedToken.kind)
            matchedToken.kind = jjcurKind;
         jjcurKind = 2147483647;
      }
   }
   return;
}
static long jjnewActive_00 = 0L, jjoldActive_00 = 0L;
static private final void jjMoveStringLiteralDfa0_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
         switch(curChar)
         {
            case (61) : 
               matchedToken.kind = 15;
               break ReturnLoop;
            case (59) : 
               matchedToken.kind = 14;
               break ReturnLoop;
            case (46) : 
               matchedToken.kind = 12;
               break ReturnLoop;
            case (42) : 
               matchedToken.kind = 13;
               break ReturnLoop;
            case (32) : 
               matchedToken.kind = 1;
               break ReturnLoop;
            case (125) : 
               matchedToken.kind = 17;
               break ReturnLoop;
            case (123) : 
               matchedToken.kind = 16;
               break ReturnLoop;
            case (13) : 
               matchedToken.kind = 4;
               break ReturnLoop;
            case (12) : 
               matchedToken.kind = 5;
               break ReturnLoop;
            case (10) : 
               matchedToken.kind = 3;
               break ReturnLoop;
            case (9) : 
               matchedToken.kind = 2;
               break ReturnLoop;
            case (109) : 
              jjoldActive_00 = 0x400L;
               break;
            case (107) : 
              jjoldActive_00 = 0x800L;
               break;
            case (105) : 
              jjoldActive_00 = 0x200L;
               break;
            default : 
               if (curChar < 128)
               {
                  if ((jjstartStateSet = jjinitStates_0[curChar]) == null)
                  {
                     curPos = 1;
                     return;
                  }
               }
               else 
                  jjstartStateSet = jjallInitStates_0;
               jjStartNfa_0(0, 0L);
               return;
         }
         jjMoveStringLiteralDfa1_0();
         return;
    }
   }
   curPos = 1;
   return;
}
static private final void jjMoveStringLiteralDfa1_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (97) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x400L)) == 0L)
                 break StartNfaLoop;
               break;
            case (109) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x200L)) == 0L)
                 break StartNfaLoop;
               break;
            case (101) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x800L)) == 0L)
                 break StartNfaLoop;
               break;
            default : 
               jjStartNfa_0(1, jjoldActive_00); 
               return;
         }
         jjMoveStringLiteralDfa2_0();
         return;
}
   jjStartNfa_0(1, jjoldActive_00); 
   return;
} catch(java.io.IOException e) {
   if (curChar < 128)
   {
      if ((jjstartStateSet = jjinitStates_0[curChar]) == null)
      {
         curPos = 2;
         return;
      }
   }
   else 
      jjstartStateSet = jjallInitStates_0;
   jjStartNfa_0(0, 0L);
   return;
}
    }
   }
}
static private final void jjMoveStringLiteralDfa2_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (99) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x400L)) == 0L)
                 break StartNfaLoop;
               break;
            case (121) : 
               if ((jjnewActive_00 & 0x800L) != 0L)
               {
                  matchedToken.kind = 11;
                  jjstartStateSet = jjstates13;
                  break MainLoop;
                  }
            break StartNfaLoop;
            case (112) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x200L)) == 0L)
                 break StartNfaLoop;
               break;
            default : 
               jjStartNfa_0(2, jjnewActive_00); 
               return;
         }
         jjMoveStringLiteralDfa3_0();
         return;
}
   jjStartNfa_0(2, jjnewActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(1, jjoldActive_00); 
   return;
}
    }
   jjmatchedPos = 2;
   curPos = 3;
   curChar = input_stream.readChar();
   jjnewStateCnt = jjstartStateSet.length;
   jjMoveNfa_0(jjstartStateSet, jjstateSet2);
   if (jjcurKind != 2147483647)
   {
      matchedToken.kind = jjcurKind;
      jjmatchedPos = 3;
      jjcurKind = 2147483647;
   }
   curPos = 4;
   return;
   }
}
static private final void jjMoveStringLiteralDfa3_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (114) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x400L)) == 0L)
                 break StartNfaLoop;
               break;
            case (111) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x200L)) == 0L)
                 break StartNfaLoop;
               break;
            default : 
               jjStartNfa_0(3, jjoldActive_00); 
               return;
         }
         jjMoveStringLiteralDfa4_0();
         return;
}
   jjStartNfa_0(3, jjoldActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(2, jjnewActive_00); 
   return;
}
    }
   }
}
static private final void jjMoveStringLiteralDfa4_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (114) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x200L)) == 0L)
                 break StartNfaLoop;
               break;
            case (111) : 
               if ((jjnewActive_00 & 0x400L) != 0L)
               {
                  matchedToken.kind = 10;
                  jjstartStateSet = jjstates13;
                  break MainLoop;
                  }
            break StartNfaLoop;
            default : 
               jjStartNfa_0(4, jjnewActive_00); 
               return;
         }
         jjMoveStringLiteralDfa5_0();
         return;
}
   jjStartNfa_0(4, jjnewActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(3, jjoldActive_00); 
   return;
}
    }
   jjmatchedPos = 4;
   curPos = 5;
   curChar = input_stream.readChar();
   jjnewStateCnt = jjstartStateSet.length;
   jjMoveNfa_0(jjstartStateSet, jjstateSet2);
   if (jjcurKind != 2147483647)
   {
      matchedToken.kind = jjcurKind;
      jjmatchedPos = 5;
      jjcurKind = 2147483647;
   }
   curPos = 6;
   return;
   }
}
static private final void jjMoveStringLiteralDfa5_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (116) : 
               if ((jjoldActive_00 & 0x200L) != 0L)
               {
                  matchedToken.kind = 9;
                  jjstartStateSet = jjstates13;
                  break MainLoop;
                  }
            break StartNfaLoop;
            default : 
               jjStartNfa_0(5, jjoldActive_00); 
               return;
         }
}
   jjStartNfa_0(5, jjoldActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(4, jjnewActive_00); 
   return;
}
    }
   jjmatchedPos = 5;
   curPos = 6;
   curChar = input_stream.readChar();
   jjnewStateCnt = jjstartStateSet.length;
   jjMoveNfa_0(jjstartStateSet, jjstateSet2);
   if (jjcurKind != 2147483647)
   {
      matchedToken.kind = jjcurKind;
      jjmatchedPos = 6;
      jjcurKind = 2147483647;
   }
   curPos = 7;
   return;
   }
}
static final int[] jjstates0 = { 1, 2, };
static final int[] jjstates1 = { 3, };
static final int[] jjstates2 = { 6, };
static final int[] jjstates3 = { 10, 6, };
static final int[] jjstates4 = { 10, };
static final int[] jjstates5 = { 12, };
static final int[] jjstates6 = { 8, 9, 11, };
static final int[] jjstates7 = { 5, 7, };
static final int[] jjstates8 = { 14, 15, 17, };
static final int[] jjstates9 = { 14, 15, 19, 17, };
static final int[] jjstates10 = { 19, };
static final int[] jjstates11 = { 21, };
static final int[] jjstates12 = { 16, 18, 20, };
static final int[] jjstates13 = { 23, };
static final int[] jjstates14 = { 28, };
static final int[] jjstates15 = { 26, 27, 29, };
static final int[] jjstates16 = { 34, 32, };
static final int[] jjstates17 = { 32, 33, 35, };
static final int[] jjstates18 = { 31, 32, };
static final int[] jjstates19 = { 30, };
static final int[] jjstates20 = { 41, 39, };
static final int[] jjstates21 = { 39, 40, 42, };
static final int[] jjstates22 = { 38, 39, };
static final int[] jjstates23 = { 25, 36, 37, };
static final int[] jjallInitStates_0 = { 0, 3, 4, 13, 22, 24, };
static final int[] jjstates24 = { 13, };
static final int[] jjstates25 = { 22, };
static final int[] jjstates26 = { 4, };
static final int[] jjstates27 = { 24, };
static final int[] jjstates28 = { 0, };
static final int[][] jjinitStates_0 = {
jjallInitStates_0, null, null, null, null, null, 
null, null, null, null, null, 
null, null, null, null, null, 
null, null, null, null, null, 
null, null, null, null, null, 
null, null, null, null, null, 
null, null, null, jjstates24, null, 
jjstates25, null, null, jjstates26, null, 
null, null, null, null, null, 
null, jjstates27, jjstates1, jjstates1, jjstates1, 
jjstates1, jjstates1, jjstates1, jjstates1, jjstates1, 
jjstates1, jjstates1, null, null, null, 
null, null, null, null, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates28, null, null, null, jjstates25, 
null, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, jjstates25, jjstates25, jjstates25, 
jjstates25, jjstates25, null, null, null, 
null, null, };

public static final String[] jjstrLiteralImages = {
null, null, null, null, null, null, null, null, null, 
"\151\155\160\157\162\164", "\155\141\143\162\157", "\153\145\171", "\56", "\52", "\73", "\75", "\173", 
"\175", null, null, null, null, null, null, null, };
public static final String[] lexStateNames = {
   "DEFAULT", 
};
static final long[] jjtoToken = 
{
0x7ffe00L,
};
static final long[] jjtoSkip = 
{
0x1feL,
};
static final long[] jjtoSpecial = 
{
0x1c0L,
};
static private ASCII_UCodeESC_CharStream input_stream;
static private int[] jjrounds = new int[43];
static private int[] jjstateSet1 = new int[43];
static private int[] jjstateSet2 = new int[43];
static private int[] jjnextStates;
static int curPos;
static protected char curChar;
static int jjcurKind = 2147483647;
static KeyConfigTokenManager jjme;
public KeyConfigTokenManager(ASCII_UCodeESC_CharStream stream)
{
if (input_stream != null)
{
   System.err.println("ERROR: Second call to constructor of static lexer.  You must");
   System.err.println("       either use ReInit() or set the JavaCC option STATIC to false");
   System.err.println("       during lexer generation.");
   throw new Error();
}
input_stream = stream;
jjme = this;
}
public KeyConfigTokenManager(ASCII_UCodeESC_CharStream stream, int lexState)
{
if (input_stream != null)
{
   System.err.println("ERROR: Second call to constructor of static lexer.  You must");
   System.err.println("       either use ReInit() or set the JavaCC option STATIC to false");
   System.err.println("       during lexer generation.");
   throw new Error();
}
input_stream = stream;
jjme = this;
   if (lexState >= 1 || lexState < 0)
   {
      System.out.println("Error: Ignoring invalid lexical state : " + lexState + ". Starting lexer in DEFAULT state.");
      curLexState = defaultLexState;
   }
   else
      curLexState = lexState;
}
static public void ReInit(ASCII_UCodeESC_CharStream stream)
{
int i;
jjcurKind = 2147483647;
curPos = jjmatchedPos = jjnewStateCnt = jjround = 0;
jjstartStateSet = null;
curChar = (char)0;
jjEOFSeen = false;
curLexState = defaultLexState;
input_stream = stream;
for (i = 43; i-- > 0;)
   jjrounds[i] = 0;
}
static public void ReInit(ASCII_UCodeESC_CharStream stream, int lexState)
{
int i;
jjcurKind = 2147483647;
curPos = jjmatchedPos = jjnewStateCnt = jjround = 0;
jjstartStateSet = null;
curChar = (char)0;
jjEOFSeen = false;
   if (lexState >= 1 || lexState < 0)
   {
      System.out.println("Error: Ignoring invalid lexical state : " + lexState + ". Reinitialzing lexer in DEFAULT state.");
      curLexState = defaultLexState;
   }
   else
      curLexState = lexState;
input_stream = stream;
for (i = 43; i-- > 0;)
   jjrounds[i] = 0;
}
static public void SwitchTo(int lexState)
{
   if (lexState >= 1 || lexState < 0)
      System.out.println("Error: Ignoring invalid lexical state : " + lexState + ". State unchanged.");
   else
      curLexState = lexState;
}


static int curLexState = 0;
static int defaultLexState = 0;
static int jjnewStateCnt;
static int jjround;
static private boolean jjEOFSeen = false;
static int[] jjtmpStates = jjstateSet1;
static int jjmatchedPos;
static Token matchedToken;
static Token jjspecialToken;
static private int[] jjstartStateSet;

static public Token getNextToken() throws ParseError
{
  matchedToken = new Token();

  EOFLoop : for (;;)
  {   
   try   
   {     
      curChar = input_stream.BeginToken();
   }     
   catch(java.io.IOException e)
   {        
      matchedToken.endLine = matchedToken.beginLine = input_stream.getBeginLine();
      matchedToken.endColumn = matchedToken.beginColumn = input_stream.getBeginColumn();
      matchedToken.kind = 0;
      matchedToken.image = "";
      matchedToken.specialToken = jjspecialToken;
      jjspecialToken = null;
      return matchedToken;
   }

   try
   {
    for (;;)
    {
      matchedToken.kind = 2147483647;
      jjmatchedPos = 0;
      jjMoveStringLiteralDfa0_0();
      while (jjnewStateCnt != 0)
      {
         curChar = input_stream.readChar();
         jjMoveNfa_0(jjstateSet1 = jjstateSet2, jjstateSet2 = jjtmpStates);
         jjtmpStates = jjstateSet1;
         if (jjcurKind != 2147483647)
         {
            matchedToken.kind = jjcurKind;
            jjcurKind = 2147483647;
            jjmatchedPos = curPos++;
         }
         else
            curPos++;
      }

      if (matchedToken.kind != 2147483647)
      {
         if (jjmatchedPos + 1 < curPos)
            input_stream.backup(curPos - jjmatchedPos - 1);

         if ((jjtoToken[matchedToken.kind >> 6] &
             (1L << (matchedToken.kind & 077))) != 0L)
         {
            if ((matchedToken.image = jjstrLiteralImages[matchedToken.kind]) == null)
               matchedToken.image = input_stream.GetImage();
            matchedToken.beginLine = input_stream.getBeginLine();
            matchedToken.beginColumn = input_stream.getBeginColumn();
            matchedToken.endLine = input_stream.getEndLine();
            matchedToken.endColumn = input_stream.getEndColumn();
            matchedToken.specialToken = jjspecialToken;
            jjspecialToken = null;
            return matchedToken;
         }
         else
         {
            if ((jjtoSpecial[matchedToken.kind >> 6] &
                (1L << (matchedToken.kind & 077))) != 0L)
            {
               if ((matchedToken.image = jjstrLiteralImages[matchedToken.kind]) == null)
                  matchedToken.image = input_stream.GetImage();
               matchedToken.beginLine = input_stream.getBeginLine();
               matchedToken.beginColumn = input_stream.getBeginColumn();
               matchedToken.endLine = input_stream.getEndLine();
               matchedToken.endColumn = input_stream.getEndColumn();
               if (jjspecialToken == null)
                  jjspecialToken = matchedToken;
               else
               {
                  matchedToken.specialToken = jjspecialToken;
                  jjspecialToken = (jjspecialToken.next = matchedToken);
               }
               matchedToken = new Token();
            }
            continue EOFLoop;
         }
      }
      else
      {
         jjme.error_line = input_stream.getEndLine();
         jjme.error_column = input_stream.getEndColumn();
         input_stream.backup(1);
         jjme.error_after = curPos <= 1 ? "" : jjadd_escapes(input_stream.GetImage());
         jjme.LexicalError();

         throw new ParseError();
      }
    }
   }
   catch (java.io.IOException e)
   {
      switch(curLexState)
      {
         default : break;
      }
      if (matchedToken.kind != 2147483647 && matchedToken.kind != 0)
      {
         if (jjmatchedPos + 1 < curPos)
            input_stream.backup(curPos - jjmatchedPos - 1);

         if ((jjtoToken[matchedToken.kind >> 6] &
             (1L << (matchedToken.kind & 077))) != 0L)
         {
            if ((matchedToken.image = jjstrLiteralImages[matchedToken.kind]) == null)
               matchedToken.image = input_stream.GetImage();
            matchedToken.beginLine = input_stream.getBeginLine();
            matchedToken.beginColumn = input_stream.getBeginColumn();
            matchedToken.endLine = input_stream.getEndLine();
            matchedToken.endColumn = input_stream.getEndColumn();
            matchedToken.specialToken = jjspecialToken;
            jjspecialToken = null;
            return matchedToken;
         }
         else
         {
            if ((jjtoSpecial[matchedToken.kind >> 6] &
                (1L << (matchedToken.kind & 077))) != 0L)
            {
               if ((matchedToken.image = jjstrLiteralImages[matchedToken.kind]) == null)
                  matchedToken.image = input_stream.GetImage();
               matchedToken.beginLine = input_stream.getBeginLine();
               matchedToken.beginColumn = input_stream.getBeginColumn();
               matchedToken.endLine = input_stream.getEndLine();
               matchedToken.endColumn = input_stream.getEndColumn();
               if (jjspecialToken == null)
                  jjspecialToken = matchedToken;
               else
               {
                  matchedToken.specialToken = jjspecialToken;
                  jjspecialToken = (jjspecialToken.next = matchedToken);
               }
               matchedToken = new Token();
            }
            continue EOFLoop;
         }
      }

      jjme.error_line = input_stream.getEndLine();
      jjme.error_column = input_stream.getEndColumn();
      input_stream.backup(1);
      jjEOFSeen = true;
      jjme.error_after = curPos <= 1 ? "" : jjadd_escapes(input_stream.GetImage());
      jjme.LexicalError();

      throw new ParseError();
   }
  }
}

protected int error_line, error_column;
protected String error_after;
protected void LexicalError()
{
   System.err.println("Lexical error at line " +
        error_line + ", column " +
        error_column + ".  Encountered: " +
        (jjEOFSeen ? "<EOF>" : ("\"" + jjadd_escapes(String.valueOf(curChar)) + "\"") + " (" + (int)curChar + "), ") +
        "after : \"" + jjme.error_after + "\"");
}
}
