/**
* Xelfi programming environment
*/

package xelfi.util;
/**
* This interface defines basic operation that every node that is used by
* BinaryTreeOperation methods must follow.
* @see BinaryTreeOperation
*
* @version 1.0
* @author Jaroslav Tulach
*/

public interface BinaryTreeNode {
  /** @return left son of this node */
  public BinaryTreeNode getLeftSon ();
  /** @return right son of this node */
  public BinaryTreeNode getRightSon ();
  /** @return parent this node */
  public BinaryTreeNode getParent ();
  /** Sets new left son of this node
  * @param n the new value to set
  */
  public void setLeftSon (BinaryTreeNode n);
  /** Sets new right son of this node
  * @param n the new value to set
  */
  public void setRightSon (BinaryTreeNode n);
  /** Sets new parent of this node
  * @param n the new value to set
  */
  public void setParent (BinaryTreeNode n);

  /** Gets value from the node.
  * @return the value stored in this node
  */
  public int getValue ();

  /** Sets new value to the node. Default value should be 1.
  * @param val the value to set
  */
  public void setValue (int val);
};




