/*
 * SKELETON GENERATED BY XELFI VISUAL IDE
 */

package xelfi.util;

import java.awt.*;
import xelfi.awt.Gauge;
import xelfi.awt.Panel3D;
import xelfi.awt.Timer;

/** Displays amount of free memory.
* @version 1.0
* @author Jaroslav Tulach
*/
public class MemoryView extends Frame {
  Button update;
  Button gc;
  Button cancel;
  Label numberFree;
  Gauge viewFree;
  Label numberUsed;
  Gauge viewUsed;
  Timer timer1;

  public MemoryView() {
    super ("Xelfi Memory View");
    Panel buttonpanel;
    Panel3D panel3D1;
    Panel3D panel3D2;
    
    setLayout(new BorderLayout());
    buttonpanel = new Panel();
    buttonpanel.setLayout(new FlowLayout());
    add("South", buttonpanel);

    Panel view = new Panel ();
    view.setLayout (new GridLayout (2, 1));
    
    update = new Button("Update Now");
    buttonpanel.add(update);
    gc = new Button("Garbage Collect");
    buttonpanel.add(gc);
    cancel = new Button("Cancel");
    buttonpanel.add(cancel);
    panel3D1 = new Panel3D();
    panel3D1.setLayout(new BorderLayout());
    view.add(panel3D1);
    numberFree = new Label("Amount of free memory");
    panel3D1.add("North", numberFree);
    viewFree = new Gauge();
    viewFree.setKind(Gauge.GAUGE_PIE);
    panel3D1.add("Center", viewFree);
    panel3D2 = new Panel3D();
    panel3D2.setLayout(new BorderLayout());
    view.add(panel3D2);
    numberUsed = new Label("Amount of used memory");
    panel3D2.add("North", numberUsed);
    viewUsed = new Gauge();
    viewUsed.setKind(Gauge.GAUGE_PIE);
    panel3D2.add("Center", viewUsed);

    add ("Center", view);
    timer1 = new Timer(this, 5000, true);
    timer1.start();
    addNotify();
    reshape(0, 0, 320, 253);

    updateView (null);
    show();
  }

  public boolean handleEvent(Event evt) {
    if ((evt.target == this) && (evt.id == Event.WINDOW_DESTROY)) {
      hide();
      dispose();
      return true;
    }
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == cancel)
      return onCancel(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == gc)
      return garbageCollect(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == update)
      return updateView(evt);
    else
    if (evt.target == timer1)
      return updateView(evt);
    return super.handleEvent(evt);
  }

// Event handlers

  public boolean onCancel(Event evt) {
    // Here you can write your own handling code
    hide ();
    dispose();
    return true;
  }

  public boolean garbageCollect(Event evt) {
    // Here you can write your own handling code
    System.gc ();
    updateView (evt);
    return true;
  }

  public boolean updateView(Event evt) {
    // Here you can write your own handling code
    Runtime run = Runtime.getRuntime ();
    long total = run.totalMemory ();
    long free = run.freeMemory ();
    long used = total - free;

    int nFree = (int) ((free * 100) / total);
    int nUsed = (int) ((used * 100) / total);

    numberUsed.setText ("Used memory: " + used + " bytes");
    numberFree.setText ("Free memory: " + free + " bytes");

    viewUsed.setValue (nUsed);
    viewFree.setValue (nFree);

    return true;
  }

// End of event handlers

  public static void main(String args[]) {
    new MemoryView();
  }
}


