/**
* Xelfi programming environment
*/

package xelfi.xedit;
import xelfi.editor.Position;

/**
* Info about special positions in document line
* begin and end of comments or strings.
*
* @author Jaroslav Tulach
* @version 1.0
*/
class CommentMark extends Object {
  /** Id for nothing */
  public static final byte NOTHING = 0x00;

  /** Id for begin of comment */
  public static final byte BEGIN = 0x01;

  /** Id for end of comment */
  public static final byte END = 0x02;

  /** Id for begin of line comment */
  public static final byte LINE = 0x03;

  /** Id for begin or end of string */
  public static final byte STRING = 0x04;

  /** Position in document */
  Position pos;

  /** Type of the symbol on this position */
  byte type;

  /** Type of the area from this position till the next one */
  byte area;

  /**
  * Creates new position. The area field is set to CommentInfo.UNKNOWN.
  * @param p the position to create info about
  * @param t the symbol on this position
  */
  public CommentMark (Position p, byte t) {
    this (p, t, CommentInfo.UNKNOWN);
  };

  /**
  * Creates new position. The area field is set to CommentInfo.UNKNOWN.
  * @param p the position to create info about
  * @param t the symbol on this position
  * @param a the area after position p
  */
  public CommentMark (Position p, byte t, byte a) {
    pos = p;
    type = t;
    area = a;
  };
};










// Generated from substitution template 'Class' Blocks:Class:9,41,20,41; Class:6,14,17,14; Package:8,4,19,4; 
